using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_KairosPRO._4_Vistas.Controladoras;
using Exferia_KairosPRO.General;
using Exferia_KairosPRO_EF;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_KairosPRO._4_Vistas
{
    public partial class P_Terminales : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables General
        private P_Terminales_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        //Variables paginador
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private Timer g_timer_Paginar = new Timer();
        #endregion

        #region Objetos en pantalla
        //Exferia_Button
        internal Exferia_Button Exferia_Button_Generar_ClaveTemporal { get { return ex_btn_P_Terminales_GenerarClave; } }
        internal Exferia_Button Exferia_Button_Borrar_ClaveTemporal { get { return ex_btn_P_Terminal_BorrarClave; } }

        //Exferia_CheckBox
        internal Exferia_CheckBox Exferia_CheckBox_DispositivodeHuellaDactilar { get { return ex_chk_P_Terminales_DispositivodeHuellaDactilar; } }
        internal Exferia_CheckBox Exferia_CheckBox_DispositivodeHuellaDactilar_DNS { get { return ex_chk_P_Terminales_DispositivodeHuellaDactilar_DNS; } }

        //Exferia_ComboBox
        internal Exferia_ComboBox Exferia_ComboBox_DispositivodeHuellaDactilar_Marca { get { return ex_cbo_P_Terminales_DispositivodeHuellaDactilar_Marca; } }
        internal Exferia_ComboBox Exferia_ComboBox_DispositivodeHuellaDactilar_Modelo { get { return ex_cbo_P_Terminales_DispositivodeHuellaDactilar_Modelo; } }
        internal Exferia_ComboBox Exferia_ComboBox_DispositivodeHuellaDactilar_Firmware { get { return ex_cbo_P_Terminales_DispositivodeHuellaDactilar_Firmware; } }

        //Exferia_DataGridView
        internal Exferia_DataGridView Exferia_DataGridView_Claves { get { return ex_dgv_P_Terminales_Claves; } }

        //Exferia_F3
        internal Exferia_F3 Exferia_F3_Departamento { get { return ex_usc_F3_P_Terminales_Departamento; } }

        //Exferia_Label
        internal Exferia_Label Exferia_Label_Codigo { get { return ex_lbl_P_Terminales_Codigo; } }
        internal Exferia_Label Exferia_Label_Descripcion { get { return ex_lbl_P_Terminales_Descripcion; } }
        internal Exferia_Label Exferia_Label_TipoTerminal { get { return ex_lbl_P_Terminales_TipoTerminal; } }
        internal Exferia_Label Exferia_Label_DispositivodeHuellaDactilar_IP { get { return ex_lbl_P_Terminales_DispositivodeHuellaDactilar_IP; } }
        internal Exferia_Label Exferia_Label_DispositivodeHuellaDactilar_NumeroDispositivo { get { return ex_lbl_P_Terminales_DispositivodeHuellaDactilar_NumeroDispositivo; } }
        internal Exferia_Label Exferia_Label_DispositivodeHuellaDactilar_Marca { get { return ex_lbl_P_Terminales_DispositivodeHuellaDactilar_Marca; } }
        internal Exferia_Label Exferia_Label_DispositivodeHuellaDactilar_Modelo { get { return ex_lbl_P_Terminales_DispositivodeHuellaDactilar_Modelo; } }
        internal Exferia_Label Exferia_Label_DispositivodeHuellaDactilar_Firmware { get { return ex_lbl_P_Terminales_DispositivodeHuellaDactilar_Firmware; } }
        internal Exferia_Label Exferia_Label_DispositivodeHuellaDactilar_Puerto { get { return ex_lbl_P_Terminales_DispositivodeHuellaDactilar_Puerto; } }
        internal Exferia_Label Exferia_Label_DispositivodeHuellaDactilar_Codigos_Entrada { get { return ex_lbl_P_Terminales_DispositivodeHuellaDactilar_Codigos_Entrada; } }
        internal Exferia_Label Exferia_Label_DispositivodeHuellaDactilar_Codigos_Salida { get { return ex_lbl_P_Terminales_DispositivodeHuellaDactilar_Codigos_Salida; } }

        //Exferia_Paginador
        internal Exferia_Paginador Exferia_Paginador_Terminales { get { return ex_Paginador; } }

        //Exferia_RadioButton
        internal Exferia_RadioButton Exferia_RadioButton_Oficina { get { return ex_rdb_P_Terminales_Oficina; } }
        internal Exferia_RadioButton Exferia_RadioButton_Mythos { get { return ex_rdb_P_Terminales_Mythos; } }

        //Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_Codigo { get { return ex_txt_P_Terminales_Codigo; } }
        internal Exferia_TextBox Exferia_TextBox_Descripcion { get { return ex_txt_P_Terminales_Descripcion; } }
        internal Exferia_TextBox Exferia_TextBox_DispositivodeHuellaDactilar_IP { get { return ex_txt_P_Terminales_DispositivodeHuellaDactilar_IP; } }
        internal Exferia_TextBox Exferia_TextBox_DispositivodeHuellaDactilar_NumeroDispositivo { get { return ex_txt_P_Terminales_DispositivodeHuellaDactilar_NumeroDispositivo; } }
        internal Exferia_TextBox Exferia_TextBox_DispositivodeHuellaDactilar_Puerto { get { return ex_txt_P_Terminales_DispositivodeHuellaDactilar_Puerto; } }
        internal Exferia_TextBox Exferia_TextBox_DispositivodeHuellaDactilar_Codigos_Entrada { get { return ex_txt_P_Terminales_DispositivodeHuellaDactilar_Codigos_Entrada; } }
        internal Exferia_TextBox Exferia_TextBox_DispositivodeHuellaDactilar_Codigos_Salida { get { return ex_txt_P_Terminales_DispositivodeHuellaDactilar_Codigos_Salida; } }

        //Panel
        internal Panel Panel_Codigos_Pausas { get { return pnl_P_Terminal_Codigos_Pausas; } }
        
        #endregion

        #region Constructor
        public P_Terminales(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo, DateTime _dtt_FechaTrabajo, PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle)
        {
            InitializeComponent();

            Repintar.Empezar(this);

            CheckForIllegalCrossThreadCalls = false;

            //Comprobamos que el codigo cliente exista y este bien
            if (Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO.Equals(-1))
            {
                //Tendriamos que avisar y no dejar abrir la pantalla
                Mensajes.MostrarMensaje(Mensajes.G_STR_LICENCIA_VALIDACIONES_LICENCIANOESTAACTIVA);
                Salir_P_Base();
            }

            //Empresa seleccionada y fecha de trabajo ....................................................
            P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
            P_Base_FechaTrabajo = _dtt_FechaTrabajo;

            //Instanciar Controladora
            g_obj_Controladora = new P_Terminales_Controladora(this);

            //Datos de Opciones detalle
            g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

            //Buscar los Permisos
            g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);

            //Poner los botones que no se puedan poner bloqueados o solo de lectura
            ex_btn_P_Terminales_Borrar.Exferia_Button_Bloqueable = false;
            ex_btn_P_Terminales_Grabar.Exferia_Button_Bloqueable = false;

            //Mirar si hay que bloquear los controles, si solo puede ver los datos
            if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
            {
                //Bloqueo los Controles
                SoloLectura.Empezar(this, true);
            }

            //Titulo de la Pantalla ............................................................................
            P_Base_TituloPantalla = _mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

            try
            {
                //Label con Empresa Seleccionada
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log("", ex, nameof(P_Terminales) + "/" + nameof(P_Terminales));
                    }
                }
                //..................................................................................................................................

                //Bloquear pantalla hasta que termine la carga por defecto.....
                Enabled = false;
                //.............................................................

                g_obj_Funciones_Paginador = new Funciones_Paginador();

                //Rellenar el F3.................................................

                //DEPARTAMENTOS
                ex_usc_F3_P_Terminales_Departamento.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_CTA_DEPARTAMENTO;
                ex_usc_F3_P_Terminales_Departamento.Exferia_F3_PRINCIPAL_Obligatorio = true;
                ex_usc_F3_P_Terminales_Departamento.Exferia_F3_PantallaContenedora = this;

            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                Control_Errores.Errores_Log("", ex, nameof(P_Terminales) + "/" + nameof(P_Terminales));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .............
                Enabled = true;
                //......................................................................
            }
        }
        #endregion

        #region Inicio de pantalla
        private void P_Terminales_Load(object sender, EventArgs e)
        {
            try
            {
                //Configurar el Timer para Paginacion ###############################################################
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }

                };
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_Terminales) + "/" + nameof(P_Terminales_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }

        private void P_Terminales_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (this.P_Base_TipoAperturaPantalla == 0)
                    {
                        P_Base_TituloPantalla = P_Base_TituloPantalla + " - Añadir";

                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;

                        ActivarBotones(false);

                        //Poner Texto predeterminado y foco
                        if ((P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0) ||
                            (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0))
                        {
                            if (P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0)
                            {
                                ex_txt_P_Terminales_Codigo.Text = P_Base_Campo_1;
                                ex_txt_P_Terminales_Descripcion.Exferia_TextBox_Foco();
                            }
                            if (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0)
                            {
                                ex_txt_P_Terminales_Descripcion.Text = P_Base_Campo_2;
                                ex_txt_P_Terminales_Codigo.Exferia_TextBox_Foco();
                            }
                        }
                        else
                        {
                            ex_txt_P_Terminales_Codigo.Exferia_TextBox_Foco();
                        }
                        //Si es añadir desactivamos el boton generar clave
                        ex_btn_P_Terminales_GenerarClave.Enabled = false;

                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = false;
                    }
                    //Modificar
                    else
                    {
                        ActivarBotones(true);

                        //Paginacion
                        if (P_Base_PantallaOrigen != null &&
                           P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                           P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                        {
                            g_obj_Funciones_Paginador.Listado_ARecorrer(P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.ToList(), 1);

                            // Asignando las paginas totales
                            Exferia_Paginador_Terminales.PaginasTotales = g_obj_Funciones_Paginador.Numero_Paginas_Totales;
                        }
                        else
                        {
                            Exferia_Paginador_Terminales.Visible = false;
                        }

                        g_obj_Controladora.RecargarDatos();
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_Terminales) + "/" + nameof(P_Terminales_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }

        public void ActivarBotones(bool _bol_Activar)
        {
            if (Exferia_Paginador_Terminales.Visible)
            {
                Exferia_Paginador_Terminales.Visible = _bol_Activar;
            }

            if (ex_btn_P_Terminales_Borrar.Enabled)
            {
                ex_btn_P_Terminales_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        #region Procedimientos heredados de la clase P_Base
        //Se utiliza para actualizar los listados dentro de la pantalla, sin tener que guardar
        public override void P_Base_ActualizarRegistro_ConObjeto(object _obj, G_ENUM_TIPOACCION _enum_TipoAccion)
        {
            try
            {
                if (_obj != null)
                {
                    P_Base_SeModificoDatosPantalla = true;

                    if (_enum_TipoAccion.Equals(G_ENUM_TIPOACCION.INT_INSERTAR) ||
                        _enum_TipoAccion.Equals(G_ENUM_TIPOACCION.INT_MODIFICAR))
                    {
                        List<object> lst_obj = (List<object>)_obj;
                        string obj_Opcion = (string)lst_obj[0];

                        //ClavesTemporales
                        if (obj_Opcion.Equals(Variables.G_STR_OPCION_KRS_TERMINALES))
                        {
                            g_obj_Controladora.ClavesTemporales_Actualizar_Registro((long)lst_obj[1], _enum_TipoAccion);
                        }
                    }
                    else if (_enum_TipoAccion.Equals(G_ENUM_TIPOACCION.INT_ELIMINAR))
                    {
                        List<object> lst_obj = (List<object>)_obj;
                        string obj_Opcion = (string)lst_obj[0];

                        //ClavesTemporales
                        if (obj_Opcion.Equals(Variables.G_STR_OPCION_KRS_TERMINALES))
                        {
                            g_obj_Controladora.ClavesTemporales_Borrar_Registro((List<long>)lst_obj[1]);
                        }
                    }
                    //Poner como que se modifico algo
                    P_Base_SeModificoDatosPantalla = true;
                }
            }
            catch (Exception ex)
            {
                Mensajes.MostrarMensaje(ex.Message);
            }
        }
        #endregion

        #region Botones Grabar, Borrar, BuscarCodigoSiguiente, Generar Clave, Borrar Clave
        private void ex_btn_P_Terminales_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if ( //Añadir
                (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                //Modificar
                (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
            {
                g_obj_Controladora.GrabarDatos(true);
            }
        }

        private void ex_btn_P_Terminales_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                g_obj_Controladora.BorrarDatos(true);
            }
        }

        private void ex_btn_P_Terminales_BuscarCodigoSiguiente_Click(object sender, EventArgs e)
        {
            BuscarCodigoSiguiente();
        }
        private void BuscarCodigoSiguiente()
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = g_obj_Controladora.Buscar_CodigoSiguiente();
            if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto == false && mdl_INTERNO_ValorDevuelto_Modelo.Mensaje.Trim().Length > 0)
            {
                Mensajes.MostrarMensaje(mdl_INTERNO_ValorDevuelto_Modelo.Mensaje);
            }
            else
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }

        private void ex_btn_P_Terminales_GenerarClave_Click(object sender, EventArgs e)
        {
            GenerarClave();
        }
        private void GenerarClave()
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();

            PE_ClaveTemporal frm_PE_ClaveTemporal = new PE_ClaveTemporal();
            frm_PE_ClaveTemporal.ShowDialog();

            if (frm_PE_ClaveTemporal.g_int_Tiempo_ClaveTemporal != null)
            {
                //Obtenemos la clave aleatoria y la insertamos en base de datos
                mdl_ValorDevuelto_Modelo = g_obj_Controladora.Grabar_Nueva_ClaveTemporal(frm_PE_ClaveTemporal.g_int_Tiempo_ClaveTemporal < 0 ? null : frm_PE_ClaveTemporal.g_int_Tiempo_ClaveTemporal);

                //Si todo ha ido bien, actualizamos el grid con el nuevo registro
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto)
                {
                    //Devolver el Listado el Row Añadido
                    List<object> lst_obj = new List<object>();
                    lst_obj.Add(this.g_mdl_PRV_OpcionesDetalle.opcion);
                    lst_obj.Add(mdl_ValorDevuelto_Modelo.Id);

                    P_Base_ActualizarRegistro_ConObjeto(lst_obj, mdl_ValorDevuelto_Modelo.TipoAccion);

                    P_Base_SeModificoDatosPantalla = false;
                }
            }
        }

        private void ex_btn_P_Terminal_BorrarClave_Click(object sender, EventArgs e)
        {
            BorrarClave();
        }
        private void BorrarClave()
        {
            //Ver si hay alguno seleccionado
            if (ex_dgv_P_Terminales_Claves.Rows.Count > 0 && ex_dgv_P_Terminales_Claves.SelectedRows.Count > 0)
            {
                List<long> lst_id_ClavesTemporales = new List<long>();
                foreach (DataGridViewRow dgvr in ex_dgv_P_Terminales_Claves.SelectedRows)
                {
                    lst_id_ClavesTemporales.Add(long.Parse(dgvr.Cells[nameof(KRS_Terminales_ClavesTemporales.id)].Value.ToString()));
                }

                g_obj_Controladora.BorrarDatos_ClavesTemporales(lst_id_ClavesTemporales);
            }
            else
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_NOHAYREGISTROSSELECCIONADOS());
            }
        }
        #endregion

        #region Codigos
        private void ex_btn_P_Terminales_Codigos_Pausas_Add_Click(object sender, EventArgs e)
        {
            P_Base_SeModificoDatosPantalla = true;
            g_obj_Controladora.Crear_Linea_CodigosPausa(null);
        }
        #endregion

        #region Eventos de CheckBox
        private void ex_chk_P_Terminales_DispositivodeHuellaDactilar_CheckedChanged(object sender, EventArgs e)
        {
            ex_pnl_DatosDispositivoHuellaDactilar.Visible = ((Exferia_CheckBox)sender).Checked;
        }
        private void ex_chk_P_Terminales_MostrarTodo_CheckedChanged(object sender, EventArgs e)
        {
            if (ex_chk_P_Terminales_MostrarTodo.Checked)
            {
                //Rellenamos el listado con todos los registros para ese Terminal en base de datos
                g_obj_Controladora.Rellenar_Listado_ClavesTemporales();
            }
            else
            {
                //Vaciamos el listado hasta que queden 5 registros
                g_obj_Controladora.Vaciar_Listado_ClavesTemporales();
            }
        }
        #endregion

        #region Eventos del paginador
        protected void ctu_Paginacion_Primera_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) //Si no han habido contratiempospasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Primera())
                {
                    //Asignando al control la pagina actual.
                    Exferia_Paginador_Terminales.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    //Refrescamos el listado a mostrar en el form
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        private void ctu_Paginacion_Anterior_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Anterior())
                {
                    //Asignando al control la pagina actual.
                    Exferia_Paginador_Terminales.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    //Refrescamos el listado a mostrar en el form
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void ctu_Paginacion_Siguiente_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Siguiente())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Terminales.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void ctu_Paginacion_Ultima_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Ultima())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Terminales.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void txt_PaginaActual_KeyPress(object sender, KeyPressEventArgs e)
        {
            // si pulsamos Enter.
            if (e.KeyChar.Equals('\r'))
            {
                if (g_obj_Controladora.ComprobarCambios()) //Si no han habido contratiempos pasamos a la pagina indicada
                {
                    //Asignamos a la paginacion el valor del textbox
                    g_obj_Funciones_Paginador.SetPaginaActual(Exferia_Paginador_Terminales.txt_ValorPaginaActual - 1);

                    //Asignamos al control la pagina actual
                    Exferia_Paginador_Terminales.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    //Regrescamos el listad a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_obj_Controladora.RecargarDatos();
                }
            }
        }
        #endregion

        #region Teclas de acceso rapido
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }
        #endregion

        #region Controlar si se modifica algo
        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_RadioButton_CheckedChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }

        #endregion

       
    }
}
